<HTML>
<HEAD>
<TITLE>AV-EA-01</TITLE>
<!--Expand Array Physical Drive Choices Update Page-->
<STYLE>
<!#master.css>
<!#adv.css>
</STYLE>
<META http-equiv="Content-Type" content="text/html; charset=<!=/ACU-XE/CharSet=Message>iso-8859-1<!/CharSet>">
</HEAD>
<!#common.htm>
<SCRIPT SRC="ACUTools.js"></SCRIPT>
<SCRIPT SRC="Advanced.js"></SCRIPT>
<SCRIPT SRC="checkbox.js"></SCRIPT>
<SCRIPT>
numChoices = 0;
isMigrationNecessary = false;
migrationNumChoices = 0;
defaultMigrationOption = "";
var disableNext = false;

option = new Array();
<!.Request=PDRIVE_ADD_CHOICES>
<!.Request=FOCUS>
<!.Request=TAG>
<!.Request=CONTROLLER_DUAL_DOMAIN_CAPABLE>
<!.Request=MAX_PHYS_DRIVES_PER_VOLUME>
<!.Request=PDRIVE_COUNT>
var maxNumDrivesToAdd = maxPDperLun - numDataDrives;

function HandlePhysicalDriveSelectionChange(index)
{
   NCFormReferenceArrayToggleItem(index);
   document.arrayPhysicalDrivesForm.submit();
}

function HandleSelectAll(isSelectAll)
{
   NCFormReferenceArraySelectAll(isSelectAll);
   document.arrayPhysicalDrivesForm.submit();
}

function ValidateAVEA01()
{ 
   if ( !disableNext )
   {
      disableNext = true;
      if ( requiresEven || 
           (hasNestedRAIDVolume && canDoNPGExpansion && (!canDoNDPGExpansion || (canDoNDPGExpansion && document.getElementById("EXPAND_TYPE_NPG").checked ))))
      {
         SetTaskData("updateDataFormComplete", false);
         document.updateMigrationForm.submit();
         WaitForDataReadyAndValidate();
      }
      else
      {
         Validate();
      }
   }
   return false;
}

function WaitForDataReadyAndValidate()
{
   dataComplete = GetTaskData("updateDataFormComplete");
   if ( !dataComplete )
   {
      setTimeout("WaitForDataReadyAndValidate();", 500);
   }
   else
   {
      Validate();
   }
}

function Validate()
{
   // OK, we need to determine the maximum number of physical drives a user can 
   // select given the stripe size of the array's logical drives. 
   //ACUAlert("Validate 01A");
   //return false;

   isOkToSubmit = true;
   shouldMigrate = false;
   
   // parent.AVEA01BFrame.migration is actually AV-EA-01B-Init.htm

   defaultMigrationOption = parent.AVEA01BFrame.migration.defaultOption;
   maxNumAllowed = parent.AVEA01BFrame.migration.maxNumAllowed;
   isMigrationNecessary = parent.AVEA01BFrame.migration.isNecessary;
   migrationNumChoices = parent.AVEA01BFrame.migration.numChoices;
   document.nextWithMigration.ARRAY_MIGRATION_OPTION.value = defaultMigrationOption;

   numChecked = 0;
   for( i = 0; i < numChoices; ++i )
   {
      if ( option[i].checked )
      {
         ++numChecked;
      }
   }
   
   if ( numChecked == 0 )
   {
      message = LoadString("PX_TAG_EXPAND_ARRAY_EMPTY");
      ACUAlert(message);
      isOkToSubmit = false;
   }
   else if ( numChecked > maxNumAllowed )
   {      
      message = LoadParmString(LoadString("PX_TAG_EXPAND_ARRAY_TOO_MANY_PD_SELECTED"),maxNumAllowed);
      ACUAlert(message);
      isOkToSubmit = false;
   }
   else if ( numChecked > maxNumDrivesToAdd )
   {
      message = new Object();
      message.text = LoadString("PX_TAG_EXPAND_ARRAY_TOO_MANY_DRIVES");
      message.parmLength = 1;
      message.parm = new Array();
      message.parm[0] = maxNumDrivesToAdd;
      ACUAlert(InsertParmsInString(message));
      isOkToSubmit = false;
   }
   else if ( hasNestedRAIDVolume )
   {
      var checkNumDrivesIsMultipleOf = 1;
      if (canDoNPGExpansion && (!canDoNDPGExpansion || (canDoNDPGExpansion && document.getElementById("EXPAND_TYPE_NPG").checked )))
         checkNumDrivesIsMultipleOf = minDrivesNPGExpansion;
      else
         checkNumDrivesIsMultipleOf = minDrivesNDPGExpansion;        
      if (numChecked % checkNumDrivesIsMultipleOf != 0)
      {
         message = new Object();
         message.text = LoadString("PX_TAG_EXPAND_INCORRECT_NUMBER_OF_DRIVES");
         message.parmLength = 2;
         message.parm = new Array();
         message.parm[0] = numChecked;
         message.parm[1] = checkNumDrivesIsMultipleOf;
         ACUAlert(InsertParmsInString(message));
         isOkToSubmit = false;
      }
      else
      {
         // OK to submit.
         if (canDoNPGExpansion && (!canDoNDPGExpansion || (canDoNDPGExpansion && document.getElementById("EXPAND_TYPE_NPG").checked )))
         {
            shouldMigrate = true;
            document.nextWithMigration.ARRAY_MIGRATION_OPTION.value = "EXPAND_NPG";
         }
      }
   }
   if (isOkToSubmit && requiresEven && isMigrationNecessary )
   {
      if ( migrationNumChoices > 0 )
      {
         if ( defaultMigrationOption == "RAIDADG" )
         {
            message = LoadString("PX_TAG_EXPAND_ARRAY_MIGRATE_RAIDADG");
         }
         else
         {
            message = LoadString("PX_TAG_EXPAND_ARRAY_MIGRATE_RAID5");
         }
         
         shouldMigrate = ACUConfirm(message);
         isOkToSubmit = shouldMigrate;
         if (shouldMigrate && 
             hasNestedRAIDVolume && 
             canDoNPGExpansion && 
             (!canDoNDPGExpansion || (canDoNDPGExpansion && document.getElementById("EXPAND_TYPE_NPG").checked)))
         {
            // Need to do a NPG expansion
            if ( defaultMigrationOption == "RAID6" )  
               document.nextWithMigration.ARRAY_MIGRATION_OPTION.value = "EXPAND_NPG_RAID1_TO_RAID6";
            else
               document.nextWithMigration.ARRAY_MIGRATION_OPTION.value = "EXPAND_NPG_RAID1_TO_RAID5";
         }         
      }
      else
      {
         message = LoadString("PX_TAG_EXPAND_ARRAY_EVEN_REQUIRED");
         ACUAlert(message);
         isOkToSubmit = false;
      }
   }
   if ( isOkToSubmit )
   {
      if ( shouldMigrate )
      {
         document.nextWithMigration.submit();
      }
      else
      {
         document.nextNoMigration.submit();
      }
   }
   disableNext = false;
   return false;
}

function WritePhysicalDriveCommands()
{
   for ( var i=0; i<numChoices; ++i )
   {
      physicalDriveCommand = offcommand;
      if (option[i].checked)
      {
         physicalDriveCommand = command;
      }
      WriteCommand( physicalDriveCommand, option[i].id );
   }
}

InitAdvKeyboard();
</SCRIPT>
<BODY id=BODY class=normalbody onfocus="advFocus();" onblur="advBlur();" onload="advLoad();" oncontextmenu="return DisableRightClick();">
   <TABLE width=100%  border=0 cellpadding=0 cellspacing=0 align=center >
      <TR width=100% id=configtableHead>
         <TD id=configtableHead align=left valign=top><IMG src="./Images/top_left_trans.gif"></TD>
         <TD id=configtableHead align=center nowrap>
            <SCRIPT>
            WriteString("PX_TAG_AV_EXPAND_ARRAY");
            </SCRIPT>
         </TD>
         <TD id=configtableHead align=right valign=top><IMG src="./Images/top_right_trans.gif"></TD>
      </TR>
      <TR width=100%>
         <TD id=configtable colspan=3>
         <SCRIPT>
         DisplayStandardNote("PX_TAG_NOTE_EXPAND_ARRAY_MIXED_CAPACITY");
         if (controllerDualDomainCapable)
            DisplayStandardNote("PX_TAG_NOTE_EXPAND_ARRAY_MIXED_1P_2P_SAS_DRIVES");
         if (numChoices > maxNumDrivesToAdd)
         {
            var noteParams = new Array();
            noteParams[0] = maxPDperLun;
            noteParams[1] = maxNumDrivesToAdd;
            DisplayParamNote( "PX_TAG_NOTE_EXPAND_ARRAY_MAX_DRIVES", noteParams );
         }
         if (hasNestedRAIDVolume)
         {
            DisplayStandardNote( "PX_TAG_NOTE_EXPAND_ARRAY_NESTED_RAID" );
            if (canDoNPGExpansion)
            {
               if (!canDoNDPGExpansion)
                  DisplayStandardNoteNoIcon( "PX_TAG_NOTE_EXPAND_ARRAY_NPG_ONLY" );
               var noteParams = new Array();
               noteParams[0] = minDrivesNPGExpansion;
               DisplayParamNoteNoIcon( "PX_TAG_NOTE_EXPAND_ARRAY_NPG" , noteParams );               
            }
            if (canDoNDPGExpansion)
            {
               if (!canDoNPGExpansion)
                  DisplayStandardNoteNoIcon( "PX_TAG_NOTE_EXPAND_ARRAY_NDPG_ONLY" );
               var noteParams = new Array();
               noteParams[0] = minDrivesNDPGExpansion;
               DisplayParamNoteNoIcon( "PX_TAG_NOTE_EXPAND_ARRAY_NDPG" , noteParams );               
            }
         }
         </SCRIPT>
         </TD>
      </TR>
      <TR width=100%>
         <TD id=configtable colspan=3>
            <SCRIPT>
               if (hasNestedRAIDVolume /*&& canDoNPGExpansion && canDoNDPGExpansion */)
               {
                  document.write("<FORM autocomplete='off' name='expandTypeForm'>");
                  document.write("<table width=100% border=0 cellpadding=2 cellspacing=4 id='SELECT_ALL' class=normal>");
                  document.write("<tr id=advTableHeader width=100% align=absMiddle>");
                  document.write("<td width=100% id=advTableHeader align=center>");
                  document.write( LoadString("PX_TAG_EXPANSION_TYPE") );
                  document.write("</td></tr><tr id=advTable align=absmiddle>");
                  document.write("<td id=advTable width=100% align=center>");

                  document.write("<table id=advTable width=100% align=center border=0>");
                  document.write("<tr id=advTable><td id=advTable>");
                  
                  document.write("<input type=radio name='EXPAND_TYPE' value='EXPAND_NPG' id='EXPAND_TYPE_NPG'");
                  if (canDoNPGExpansion)
                  {
                     document.write(" checked");
                  }
                  else
                  {
                     document.write(" disabled");
                  }
                  document.write(">");
                  
                  document.write(LoadString("PX_TAG_EXPANSION_TYPE_NPG"));
                  document.write("</td></tr></table>");

                  document.write("<table id=advTable width=100% align=center border=0>");
                  document.write("<tr id=advTable><td id=advTable>");
                  document.write("<input type=radio name='EXPAND_TYPE' value='EXPAND_NDPG' id='EXPAND_TYPE_NDPG'");
                  if ( !canDoNDPGExpansion )
                  {
                     document.write(" disabled");
                  }
                  else if ( !canDoNPGExpansion )
                  {
                     document.write(" checked");
                  }
                  document.write(">");
                  document.write(LoadString("PX_TAG_EXPANSION_TYPE_NDPG"));
                  document.write("</td></tr></table>");
                  
                  document.write("</td></tr></table></FORM>");
                  if ( canDoNPGExpansion && canDoNDPGExpansion )
                  {
                     AddKBIndex("EXPAND_TYPE_NPG");
                     kbIdArray["EXPAND_TYPE_NPG"].isCheckbox=true;
                     AddKBIndex("EXPAND_TYPE_NDPG");
                     kbIdArray["EXPAND_TYPE_NDPG"].isCheckbox=true;
                  }
               }
            </SCRIPT>
         </TD>
      </TR>
      <FORM autocomplete="off" name="displayForm">
      <TR width=100%>
         <TD id=configtable colspan=3>
            <SCRIPT>
            DisplayStandardCheckBoxTable(LoadString("PX_TAG_AV_PDRIVE_SELECT_FOR_EXPAND"), option, numChoices, "HandlePhysicalDriveSelectionChange", "HandleSelectAll", "./Images/GnACUPDriveAll.gif");
            </SCRIPT>
         </TD>
      </TR>
      </FORM>         
      <TR id=configtable>
         <TD id=configtable colspan=3>
            <SCRIPT>
            DisplayStandardOKCancelButtonNavWithValidation("AV-Config.htm", "AV-Config.htm", "ValidateAVEA01()" );
            </SCRIPT>
         </TD>
      </TR>
   </TABLE>
   <FORM name="arrayPhysicalDrivesForm" method="post" target="AdvancedData1" action="ACUBlank.htm">
      <SCRIPT>
      WritePhysicalDriveCommands();
      insertUserAndFocus();
      </SCRIPT>
   </FORM>
   <SCRIPT>
      NCFormReferenceArrayInit( document.arrayPhysicalDrivesForm );
   </SCRIPT>
   <FORM name="updateMigrationForm" method="post" target="AVEA01BFrame" action="AV-EA-01B.htm">
      <SCRIPT>
      insertUser();
      insertFocus();
      insertSource();
      </SCRIPT>
   </FORM>
   <FORM name="nextNoMigration" method="post" target="config" action="AV-Config.htm">
   <SCRIPT>
      WriteCommand( "END_ADD_PDRIVE", "DEFAULT");
      insertUser();
      insertFocus();
      insertSource();
      WriteCommand( "END_TRANSACTION", "DEFAULT" );
      </SCRIPT>
   </FORM>
   <FORM name="cancel">
      <SCRIPT>
      insertUser();
      insertFocus();
      insertSource();
      WriteCommand("UNDO_TRANSACTION","DEFAULT");
      </SCRIPT>
   </FORM>
   <FORM name="nextWithMigration" method="post" target="config" action="AV-Config.htm">
      <SCRIPT>
      WriteCommand( "END_ADD_PDRIVE", "DEFAULT");
      WriteCommand( "ARRAY_MIGRATION_OPTION", "" );
      insertUser();
      insertFocus();
      insertSource();
      WriteCommand( "END_TRANSACTION", "DEFAULT" );
      </SCRIPT>
   </FORM>
</BODY>
<SCRIPT SRC="advkey.js"></SCRIPT>
</HTML>