<!--
History:
   XXDDMMMYY Created??
   mm26Sep06 Added a refresh button due to popular demand.
-->

<HTML>
<HEAD>
<TITLE></TITLE>
<META http-equiv=Content-Type content="text/html; charset=<!=CharSet=Content>iso-8859-1<!/CharSet>">
<LINK rel=stylesheet href="ADU.css" type="text/css">
<link rel="stylesheet" type="text/css" href="css/default.css">
<link rel="stylesheet" type="text/css" href="css/blue_theme.css">
<script language="JavaScript" type="text/javascript" src="js/buttonManager.js"></script>
<script language="JavaScript" type="text/javascript" src="js/global.js"></script>
<SCRIPT SRC="ADUTools.js"></SCRIPT>

<SCRIPT language="JavaScript">
   var g_isMoz = false;
   var statusRequestor;
   var contentRequestor;
   var isADUReportDone = false;

   
   if(window.navigator != null && window.navigator.userAgent.indexOf("ecko") != -1)
   {
      g_isMoz = true;
   }
   function CreateRequestor()
   {
      var newRequestor;
      if (g_isMoz && window.XMLHttpRequest) 
      {
         try      {  newRequestor = new XMLHttpRequest(); } 
         catch(e) {  newRequestor = false;                }
      }
      else if(window.ActiveXObject) 
      {
         try      {  newRequestor = new ActiveXObject("Microsoft.XMLHTTP"); } 
         catch(e) {  newRequestor = false;                                  }
      }
      return newRequestor;
   }

   function RefreshPageStatus()
   {      
      statusRequestor = CreateRequestor();
      if (statusRequestor)
      {
         statusRequestor.onreadystatechange = StatusResponseHandler;
         statusRequestor.open("GET", "ADUReportStatus.js", true);
         statusRequestor.send("");
      }
      else
      {
         alert("Fatal error: Unable to create asynchronous requestor. Please close your web browser and restart the application.");
      }      
   }
   function StatusResponseHandler()
   {
      if (statusRequestor.readyState == 4) 
      {
         if (statusRequestor.status == 200 || statusRequestor.status == 0) 
         {
            eval(statusRequestor.responseText);
            if (!isADUReportDone || (isADUReportDone && !isADUReportWritten))
            {
               setTimeout("RefreshPageStatus();", 100);
            }
            else
            {
               EnableSaveButton();
            }
         } 
      }
   }
   function ReadReportContents()
   {      
      contentRequestor = CreateRequestor();
      if (contentRequestor)
      {
         contentRequestor.onreadystatechange = ContentResponseHandler;
         contentRequestor.open("GET", "ADUHTMLReport.htm", true);
         contentRequestor.send("");
      }
      else
      {
         alert("Fatal error: Unable to create asynchronous requestor. Please close your web browser and restart the application.");
      }      
   }
   function ContentResponseHandler()
   {
      if (contentRequestor.readyState == 4) 
      {
         if (contentRequestor.status == 200 || contentRequestor.status == 0) 
         {
            document.getElementById("ADU_REPORT_AREA").innerHTML = contentRequestor.responseText;
            document.getElementById("processMessage").style.display = "none";
            document.getElementById("ADU_REPORT_AREA").style.display = "";
         } 
      }
   }

   function onLoadHandler()
   {
      onResizeHandler();
      ReadReportContents();
      RefreshPageStatus();
   }
   function onResizeHandler()
   {
      var headerTable = document.getElementById("HEADER_TABLE");
      var containerDIV = document.getElementById("ADU_CONTAINER_AREA");
      containerDIV.style.top = headerTable.offsetHeight + 12 + "px";
      containerDIV.style.height = document.body.clientHeight - headerTable.offsetHeight - 24 + "px";
      containerDIV.style.width = document.body.clientWidth - 24 + "px";
   }
   function ScrollToADUReportTop()
   {
      var container = document.getElementById("ADU_CONTAINER_AREA");
      container.scrollTop = 0;
   }
   function ScrollToADUReportDevice(deviceID)
   {
      var elem = document.getElementById(deviceID);
      var elementOffsetTop = elem.offsetTop;      
      var container = document.getElementById("ADU_CONTAINER_AREA");
      if (container)
      {
         container.scrollTop = elementOffsetTop;
      }
      else
      {
         window.scrollTo(0, elementOffsetTop);         
      }
   }
   function ScrollToADUReportDeviceSection(deviceID, sectionID)
   {
      var elem = document.getElementById(deviceID);
      var sections = elem.getElementsByTagName("TR");
      var container = document.getElementById("ADU_CONTAINER_AREA");
      for (var j = 0; j < sections.length; j++)
      {
         if (sections[j].className == "captionRow")
         {
            if (sections[j].id == sectionID)
            {
               container.scrollTop = elem.offsetTop + sections[j].offsetTop;
               break;
            }
         }
      }
   }
   
 function EnableSaveButton()
 {
   f = top.ADUAppFooter;
   if(f)
   {
    if(f.getButtonManagerRef)
    {
      o = f.getButtonManagerRef();
      if(o)
      {
       o.enableButtonById("ADUSaveButton");
       o.enableButtonById("ADURefreshButton");
      }
    }
    
   }
 }
</SCRIPT>
</HEAD>
<BODY style="width:100%; height:100%;" class="greyPanel" oncontextmenu="return false;" onload="onLoadHandler();" onresize="onResizeHandler();">
<table id="HEADER_TABLE" style="position:absolute;" width="100%" border="0" cellpadding="0" cellspacing="0">
 <TR>
  <TD>
    <h3 class="subTitle"><!=PX_TAG_COMPLETED_REPORT=Content>Completed Report<!/PX_TAG_COMPLETED_REPORT></h3>
    <div class="subTitleBottomEdge"></div>
  </TD>
 </TR>
</table>
<DIV id="ADU_CONTAINER_AREA" style="position:absolute;left:12px;overflow:auto;background:#fff;">
<DIV id="processMessage" class="processing"><!=PX_TAG_FORMATTING_DIAG_REPORT=Content>Formatting Report ...<!/PX_TAG_FORMATTING_DIAG_REPORT></DIV>
<DIV id="ADU_REPORT_AREA" lang="en" style="display:none;"></DIV>
</DIV>
</BODY>
</HTML>
