<?php
include "fefunctions.php";
include "iocommand.php";
start_session();

$_SESSION["page"] = "configverifyform.php";

   /***********************************************************************
   *    Copyright  2002 - 2005 Hewlett-Packard Development Company, L.P. *
   ***********************************************************************/

?>
<html><head><title>Configuration Verification :: HP Insight Diagsnostics</title></head>
<?php
$pid = $_REQUEST["pid"];
set_time_limit(600);


if (file_exists($_SESSION["diagsDirectory"] . "cfgver.bat"))
  $cfgVerCmd = "<systemCall>" . $_SESSION["diagsDirectory"] . "cfgver.bat</systemCall>";
else if (file_exists($_SESSION["diagsDirectory"] . "configverify.pl"))
  $cfgVerCmd = "<systemCall>perl " . $_SESSION["diagsDirectory"] . "configverify.pl</systemCall>";
else
  $cfgVerCmd = "<systemCall>." . SL() . "configverify -a act_cfg.xml -o cfgveroutput.xml</systemCall>";

ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $cfgVerCmd, $returnString, $errorString);

if ($dom = @LoadXmlDocument($_SESSION["diagsDirectory"]."cfgveroutput.xml"))
{
  $configVerify = $dom->document_element();
  $result = $configVerify->get_attribute("verifyResult");
  if ($result == "failed")
  {
    if (checkDiagConfig("/factory/configVerifyCloseOnFail"))
    {
      printf("<script language='Javascript'>\nparent.parent.opener=self;\nparent.parent.close();\n</script>\n");
    }
    else
    {
      printf("<body bgcolor='red'><h1><b><font size=6><center>Configuration Verification <blink>FAILED</blink></center></font></b></h1>");
      $cfgContext = xpath_new_context($configVerify);

      printf("<table width=100%% border=1>");
      printf("<th colspan=4 bgcolor=#990000><font size=2><b>System Properties<b></font></th>");
      printf("<tr bgcolor=#CC0000><td><font size=2><b>Name</td><td><font size=2><b>Expected Value</b></font></td><td><font size=2><b>Actual Value</td><td><font size=2><b>Failure Result</td></tr>");
      $properties = xpath_eval($cfgContext, "/property");
      $num_properties = count($properties->nodeset);
      for ($p=0; $p < $num_properties; $p++)
      {
        $property = $properties->nodeset[$p];
        $propName = $property->get_attribute("name");
        $propCaption = $property->get_attribute("caption");
        $propValue = $property->get_attribute("value");
        $propVerifyResult = $property->get_attribute("verifyResult");
        $propActual = $property->get_attribute("actual");

        printf("<tr><td><font size=2>");
        if ($propCaption != "")
          printf("%s", $propCaption);
        else
          printf("%s", $propName);
        printf("</td><td><font size=2>%s</td><td><font size=2>%s</td><td><font size=2>%s</td></tr>", $propValue, $propActual, $propVerifyResult);
      }

      printf("</table><br><table width=100%% border=1>");
      printf("<th colspan=4 bgcolor=#990000><font size=2><b>System Device Failures<b></font></th>");
      printf("<tr bgcolor=#CC0000><td><font size=2><b>Name</td><td><font size=2><b>Failure Result</td></tr>");
      $devices = xpath_eval($cfgContext, "/device");
      $num_devices = count($devices->nodeset);
      for ($d=0; $d < $num_devices; $d++)
      {
        $device = $devices->nodeset[$d];
        $deviceName = $device->get_attribute("name");
        $deviceCaption = $device->get_attribute("caption");
        $deviceDescription = $device->get_attribute("description");
        $deviceVerifyResult = $device->get_attribute("verifyResult");
        $deviceClass = $device->get_attribute("class");
        printf("<tr><td><font size=2>");
        if ($deviceDescription != "")
          printf("%s",$deviceDescription);
        else if ($deviceCaption != "")
          printf("%s", $deviceCaption);
        else if ($deviceName != "")
          printf("%s", $deviceName);
        else if ($deviceClass != "")
          printf("%s", $deviceClass);
        printf("</td><td><font size=2>");
        printf("%s</td></tr>", $deviceVerifyResult);
        $deviceContext = xpath_new_context($device);
        $devproperties = @xpath_eval($deviceContext, "/property");
        $num_devproperties = count($devproperties->nodeset);
        if ($num_devproperties)
        {
          printf("<tr><td colspan=2><table width='100%%' border=1><tr bgcolor=#CC0000><td><font size=2><b>Name</b></td><td><font size=2><b>Expected Value</b></font></td><td><b><font size=2>Actual Value</td><td><font size=2><b>Failure Result</td></tr>");
          for ($dp=0; $dp < $num_devproperties; $dp++)
          {
            $devproperty = $devproperties->nodeset[$dp];
            $devicePropName = $devproperty->get_attribute("name");
            $devicePropCaption = $devproperty->get_attribute("caption");
            $devicePropValue = $devproperty->get_attribute("value");
            $devicePropVerifyResult = $devproperty->get_attribute("verifyResult");
            $devicePropertyActual = $devproperty->get_attribute("actual");

            printf("<tr><td><font size=2>");
            if ($devicePropCaption != "")
              printf("%s", $devicePropCaption);
            else if ($devicePropName != "")
              printf("%s", $devicePropName);
          
            printf("</td><td><font size=2>%s", $devicePropValue);
            printf("</td><td><font size=2>%s", $devicePropActual);
            printf("</td><td><font size=2>%s</td></tr>", $devicePropVarifyResult);          
          }
          printf("</table></td></tr>");
        }
      }
      printf("</table>");
      printf("<center><input type=button onclick=\"location.replace('hpdiags.php?pid=%s');\" value=\"Continue To Diags\"></center>", $pid);
    }
  }
  else
  { // passed
    printf("<script language='javascript'> ");
    printf("location.replace('hpdiags.php?pid=%s');", $pid);
    printf("</script>");
    
  }
}
else
  echo "config verify output does not exists (cfgveroutput.xml)";

?>
